Index: /trunk/kernel/fs/vfs.c
===================================================================
--- /trunk/kernel/fs/vfs.c	(revision 656)
+++ /trunk/kernel/fs/vfs.c	(revision 657)
@@ -3640,24 +3394,30 @@
     return error;
 
-} // end vfs_fs_new_dentry()
-
-///////////////////////////////////////////////////
-error_t vfs_fs_update_dentry( vfs_inode_t  * inode,
-                              vfs_dentry_t * dentry,
-                              uint32_t       size )
+} // end vfs_fs_new_dentry_to_mapper()
+
+//////////////////////////////////////////////////////
+error_t vfs_fs_update_dentry( xptr_t         inode_xp,
+                              vfs_dentry_t * dentry_ptr )
 {
     error_t error = 0;
 
-// check arguments
-assert( (inode  != NULL) , "inode  pointer is NULL");
-assert( (dentry != NULL) , "dentry pointer is NULL");
-
-    // get parent inode FS type
-    vfs_fs_type_t fs_type = inode->ctx->type;
+assert( (inode_xp   != XPTR_NULL) , "inode_xp argument is NULL" );
+assert( (dentry_ptr != NULL     ) , "dentry_ptr argument is NULL" );
+
+    vfs_inode_t * inode_ptr = GET_PTR( inode_xp );
+    cxy_t         inode_cxy = GET_CXY( inode_xp );
+
+    // get inode mapper
+    mapper_t * mapper = hal_remote_lpt( XPTR( inode_cxy , &inode_ptr->mapper ) );
+
+assert( (mapper != NULL) , "mapper pointer is NULL")        
+
+    // get FS type
+    vfs_fs_type_t fs_type = hal_remote_l32( XPTR( inode_cxy , &mapper->fs_type ) );
 
     // call relevant FS function
     if( fs_type == FS_TYPE_FATFS )
     {
-        error = fatfs_update_dentry( inode , dentry , size );
+        error = fatfs_update_dentry( inode_xp , dentry_ptr );
     }
     else if( fs_type == FS_TYPE_RAMFS )
@@ -3739,19 +3499,26 @@
 }  // end vfs_fs_get_user_dir()
  
-////////////////////////////////////////////////
-error_t vfs_fs_sync_inode( vfs_inode_t * inode )
+/////////////////////////////////////////////
+error_t vfs_fs_sync_inode( xptr_t  inode_xp )
 {
     error_t error = 0;
 
-// check arguments
-assert( (inode != NULL) , "inode pointer is NULL");
-
-    // get inode FS type
-    vfs_fs_type_t fs_type = inode->ctx->type;
+assert( (inode_xp != XPTR_NULL) , "inode_xp argument is NULL");
+
+    vfs_inode_t * inode_ptr = GET_PTR( inode_xp );
+    cxy_t         inode_cxy = GET_CXY( inode_xp );
+
+    // get inode mapper
+    mapper_t * mapper = hal_remote_lpt( XPTR( inode_cxy , &inode_ptr->mapper ) );
+
+assert( (mapper != NULL) , "mapper pointer is NULL")        
+
+    // get FS type
+    vfs_fs_type_t fs_type = hal_remote_l32( XPTR( inode_cxy , &mapper->fs_type ) );
 
     // call relevant FS function
     if( fs_type == FS_TYPE_FATFS )
     {
-        error = fatfs_sync_inode( inode );
+        error = fatfs_sync_inode( inode_xp );
     }
     else if( fs_type == FS_TYPE_RAMFS )
@@ -3799,59 +3566,4 @@
 }  // end vfs_fs_sync_fat()
 
-//////////////////////////////////////////////////////
-error_t vfs_fs_sync_free_info( vfs_fs_type_t fs_type )
-{
-    error_t error = 0;
-
-    // call relevant FS function
-    if( fs_type == FS_TYPE_FATFS )
-    {
-        error = fatfs_sync_free_info();
-    }
-    else if( fs_type == FS_TYPE_RAMFS )
-    {
-        assert( false , "should not be called for RAMFS" );
-    }
-    else if( fs_type == FS_TYPE_DEVFS )
-    {
-        assert( false , "should not be called for DEVFS" );
-    }
-    else
-    {
-        assert( false , "undefined file system type" );
-    }
-
-    return error;
-
-}  // end vfs_fs_sync_fat()
-
-/////////////////////////////////////////////////
-error_t vfs_fs_cluster_alloc( uint32_t   fs_type,
-                              uint32_t * cluster )
-{
-    error_t error = 0;
-
-    // call relevant FS function
-    if( fs_type == FS_TYPE_FATFS )
-    {
-        error = fatfs_cluster_alloc( cluster );
-    }
-    else if( fs_type == FS_TYPE_RAMFS )
-    {
-        assert( false , "should not be called for RAMFS" );
-    }
-    else if( fs_type == FS_TYPE_DEVFS )
-    {
-        assert( false , "should not be called for DEVFS" );
-    }
-    else
-    {
-        assert( false , "undefined file system type" );
-    }
-
-    return error;
-
-} // end vfs_fs_cluster_alloc()
-
 ////////////////////////////////////////////////
 error_t vfs_fs_release_inode( xptr_t  inode_xp )
@@ -3859,10 +3571,10 @@
     error_t error = 0;
 
-assert( (inode_xp  != XPTR_NULL) , "inode pointer is NULL")        
+assert( (inode_xp  != XPTR_NULL) , "inode_xp argument is NULL")        
 
     vfs_inode_t * inode_ptr = GET_PTR( inode_xp );
     cxy_t         inode_cxy = GET_CXY( inode_xp );
 
-    // get local pointer on page mapper 
+    // get local pointer on mapper 
     mapper_t * mapper = hal_remote_lpt( XPTR( inode_cxy , &inode_ptr->mapper ) );
 
@@ -3870,5 +3582,5 @@
 
     // get FS type from mapper
-    vfs_fs_type_t fs_type = hal_remote_l32( XPTR( inode_cxy , &mapper->type ) );
+    vfs_fs_type_t fs_type = hal_remote_l32( XPTR( inode_cxy , &mapper->fs_type ) );
 
     // call relevant FS function
@@ -3894,3 +3606,44 @@
 }  // end vfs_fs_release_inode()
 
-
+//////////////////////////////////////////////////
+error_t vfs_fs_move_page( xptr_t          page_xp,
+                          ioc_cmd_type_t  cmd_type )
+{
+    error_t error = 0;
+
+assert( (page_xp != XPTR_NULL) , "page pointer is NULL" );
+
+    page_t * page_ptr = GET_PTR( page_xp );
+    cxy_t    page_cxy = GET_CXY( page_xp );
+
+    // get local pointer on  mapper
+    mapper_t * mapper = hal_remote_lpt( XPTR( page_cxy , &page_ptr->mapper ) );
+
+assert( (mapper != NULL) , "no mapper for page" );
+
+    // get FS type
+    vfs_fs_type_t fs_type = hal_remote_l32( XPTR( page_cxy , &mapper->fs_type ) );
+
+    // call relevant FS function
+    if( fs_type == FS_TYPE_FATFS )
+    {
+        error = fatfs_move_page( page_xp , cmd_type ); 
+    }
+    else if( fs_type == FS_TYPE_RAMFS )
+    {
+        assert( false , "should not be called for RAMFS\n" );
+    }
+    else if( fs_type == FS_TYPE_DEVFS )
+    {
+        assert( false , "should not be called for DEVFS\n" );
+    }
+    else
+    {
+        assert( false , "undefined file system type" );
+    }
+
+    return error;
+
+}  // end vfs_fs_move_page()
+
+
